      SUBROUTINE parms(UND,ULENGTH,STRUCT,FLength,FStrength,FOffset,
     +                 SMAG,DEFTYP,DEFL,DEFAMP)
C=======================================================================
c
      INCLUDE  'genesis.def'
      INCLUDE  'input.cmn'
      INCLUDE  'magnet.cmn'
      INTEGER NINP
      CHARACTER*30 UND,ULength,STRUCT, FLength, FStrength, FOffset, 
     +             SMAG, DEFTYP
      REAL*8 DEFL, DEFAMP

      NINP=66
      OPEN(NINP,FILE='parms.in',STATUS='OLD',ERR=100)
c
      READ(ninp,*)  Version         ! Version number
      READ(ninp,*)  UNITLENGTH      ! Unit length
c
c define focusing structure
c
      READ(ninp,30) STRUCT          ! Focusing structure
      READ(ninp,30) FLength         ! Length of elements in unit length
      READ(ninp,30) FStrength       ! Quadrupole gradient
      READ(ninp,30) Foffset         ! Quadrupole offset in x and y (mu m)
c
c Define undulator
c
      READ(ninp,*)  IWITYP          ! Undulator type (0 is planar, 1 is helical)
      READ(ninp,*)  MAGIN           ! External magnet file (0/1) is read (n/y)
      READ(ninp,*)  NSEC            ! Number of undulator sections
      READ(ninp,*)  XLAMD           ! Undulator Period in unit length
      READ(ninp,30) UND             ! Undulator Structure
      READ(ninp,30) ULength         ! Number of unit lengths per section
      READ(ninp,*)  AW0             ! rms undulator strength
      READ(ninp,*)  DELAW           ! rms undulator error
      READ(ninp,*)  IERTYP          ! und. error (2/1/-1/-2), see Genesis
c
c Define undulator deformation
c
	READ(ninp,30) DEFTYP          ! Deformation type(constant/parabolic/sinus/sawtooth)
      READ(ninp,*)  DEFL            ! Deformation length in unit length
      READ(ninp,*)  DEFAMP          ! Deformation strength (relative)
c
c Beam parameters: needed for other programs
c
      READ(ninp,*)  GAMMA0          ! Beam energy in GeV
      READ(ninp,*)  CURPEAK         ! Beam current 
      READ(ninp,*)  EMITX           ! Normalized emittance (in mm mrad)
      READ(ninp,*)  DELGAM          ! Energy spread in MeV
      READ(ninp,*)  ITDP            ! Time dependent run (0=no)
      READ(ninp,*)  CURLEN          ! Bunch length

c
 30   format(A30)
      close(ninp)
      RETURN
c----------------------------------------------------------------------------
 100  WRITE(*,*) 'input file does not have correct format'
      WRITE(*,*) 'new version of input file is generated'
      OPEN(NINP,FILE='parms.in',STATUS='NEW')
      write(ninp,*)' 0.8         ! Version number'
      write(ninp,*)' 0.01365     ! Unit length'
c
c define focusing structure
c
      write(ninp,*)' F0D0        ! Focusing structure'
      write(ninp,*)' 12 23 12 23 ! Length of elements in unit length'
      write(ninp,*)' 10. -10.    ! Quadrupole gradient'
      write(ninp,*)' 0 0         ! Quadrupole offset in x and y (mu m)'
c
c Define undulator
c
      write(ninp,*)' 0           ! Und. type (0/1 is planar/helical)'
      write(ninp,*)' 0           ! Magnet file (0/1 is n/y): not used'
      write(ninp,*)' 3           ! Number of undulator sections'
      write(ninp,*)' 2           ! Undulator Period in unit length'
      write(ninp,*)' A0          ! Undulator Structure'
      write(ninp,*)' 327 23      ! Number of unit lengths per section'
      write(ninp,*)' 0.846000    ! rms Undulator strength'
      write(ninp,*)' 0.0         ! rms undulator error'
      write(ninp,*)' 0           ! und. error (2/1/-1/-2), see Genesis'
	write(ninp,*)' constant    ! Deformation type '//
     +                           '(constant/parabolic/sinus/sawtooth)'
      write(ninp,*)' 327         ! Deformation length in unit length'
      write(ninp,*)' 0.0         ! Deformation strength (relative)'
c
c Beam parameters: needed for other programs
c
      write(ninp,*)' 0.248       ! Beam energy in GeV'
      write(ninp,*)' 1300.00     ! Beam current '
      write(ninp,*)' 0.600E-05   ! Normalized emittance '
      write(ninp,*)' 0.20000     ! Energy spread in MeV'
      write(ninp,*)' 0           ! Time dependent run (0=no)'
      write(ninp,*)' 0.300E-04   ! Bunch length'

      close(ninp)
      STOP
      END
c     
